#!/usr/bin/env python

import os
import sys
import subprocess
import re

#location of gem-retriever binary PLUS hash file corresponde to the genome the reads are being mapped to
#HASH FILE MUST BE OBTAINED USING the FOLLOWING COMMAND LINE: gem-retriever hash P.cucumerina.eval.combined.fa Pcucumerina.eval.hash
ret = subprocess.Popen(
    " ".join([" /users/rg/fcamara/.local/lib/python2.6/site-packages/gem/gembinaries/gem-retriever",
    "query",
    "/users/rg/fcamara/Research/geneid_training/P.cucumerina/data/set1/Pcucumerina.fa.hash"]),
    stdin=subprocess.PIPE, stdout=subprocess.PIPE, shell=True)


forward = ["GT","GC","ATATC","GTATC"]
reverse = ["AG","AG","A.","AT"]

forwardc = ["CT","CT",".T","AT"]
reversec = ["AC","GC","GATAT","GATAC"]

def get_seq(chr, strand, start, length):
  left = "%s\t%s\t%d\t%d\n"%(chr, strand, start, start+4)
  right = "%s\t%s\t%d\t%d\n"%(chr, strand, start+length-5, start+length-1)
  ret.stdin.write(left+right)
  g_left = ret.stdout.readline().rstrip()
  g_right = ret.stdout.readline().rstrip()
  return (g_left, g_right)

pat = re.compile("(\d+[A-Z=])")
split_re = re.compile(".*N.*")
unknown = 0
for line in sys.stdin:
    line = line.rstrip()
    split = line.split("\t")
    if line[0] == "@" :
        print line
        continue
    start = int(split[3])
    sum = 0
    strandplus = 0
    strandminus = 0
    if not split_re.search(split[5]):
        print line
        continue
    for i in pat.findall(split[5]):
        if i[-1] == "N":
            left, right = get_seq(split[2], "+", start+sum, int(i[:-1]))
            ## get sequence
            strand = None
            for j,f in enumerate(forward):
                if re.search("^"+f, left):
                    if re.search(reverse[j]+"$", right ):
                        strand = "+"
                        strandplus += 1
            #if strand is None:
            for j,f in enumerate(forwardc):
                if re.search("^"+f, left):
                    if re.search(reversec[j]+"$", right ):
                         strand = "-"
                         strandminus += 1
            if (strandplus > 0 and strandminus == 0) or (strandplus == 0 and strandminus > 0):
                split.append("XS:A:"+strand)
                print "\t".join(split)
            else:
                unknown += 1

            break
        sum = sum + int(i[:-1])

sys.stderr.write("Unknown and ignored splitmaps %d\n"%unknown)
ret.kill()
